Lootscan_Settings = {
	MinimapPos = 45 -- default position of the minimap icon in degrees

}
RollTable = {}
iRollTable = 1
LootTable = {}
iLootTable = 1
ninjaLootTable = {}
ininjaLootTable = 1
fontheight = 14
framescale = 1


function LootScan_OnLoad()
this:RegisterEvent("VARIABLES_LOADED");
Lootscan1.caption = Lootscan1:CreateTexture(nil, "OVERLAY")
Lootscan1.caption:SetTexture("Interface\\Addons\\Lootscan\\icon-logo")
Lootscan1.caption:SetWidth(55)
Lootscan1.caption:SetHeight(55)
Lootscan1.caption:SetPoint("TOPLEFT", 0, 1)


Lootscan1.clearicon = Lootscan1:CreateTexture(nil, "OVERLAY")
Lootscan1.clearicon:SetTexture("Interface\\Addons\\Lootscan\\icon-reset")
Lootscan1.clearicon:SetWidth(16)
Lootscan1.clearicon:SetHeight(16)
Lootscan1.clearicon:SetPoint("TOPLEFT", 145, -4)

Lootscan1.reporticon = Lootscan1:CreateTexture(nil, "OVERLAY")
Lootscan1.reporticon:SetTexture("Interface\\Buttons\\UI-GuildButton-MOTD-Up")
Lootscan1.reporticon:SetWidth(16)
Lootscan1.reporticon:SetHeight(16)
Lootscan1.reporticon:SetPoint("TOPLEFT", 90, -4)

Lootscan1.closeicon = Lootscan1:CreateTexture(nil, "OVERLAY")
Lootscan1.closeicon:SetTexture("Interface\\Addons\\Lootscan\\icon-exit")
Lootscan1.closeicon:SetWidth(16)
Lootscan1.closeicon:SetHeight(16)
Lootscan1.closeicon:SetPoint("TOPLEFT", 175, -4)

Lootscan1.officon = Lootscan1:CreateTexture(nil, "OVERLAY")
Lootscan1.officon:SetTexture("Interface\\Addons\\Lootscan\\icon-off")
Lootscan1.officon:SetWidth(18)
Lootscan1.officon:SetHeight(18)
Lootscan1.officon:SetPoint("TOPLEFT", 70, -2)

Lootscan1.onicon = Lootscan1:CreateTexture(nil, "OVERLAY")
Lootscan1.onicon:SetTexture("Interface\\Addons\\Lootscan\\icon-on")
Lootscan1.onicon:SetWidth(18)
Lootscan1.onicon:SetHeight(18)
Lootscan1.onicon:SetPoint("TOPLEFT", 70, -2)

Lootscan1.ninjas = Lootscan1:CreateTexture(nil, "OVERLAY")
Lootscan1.ninjas:SetTexture("Interface\\Addons\\Lootscan\\ninjas")
Lootscan1.ninjas:SetWidth(35)
Lootscan1.ninjas:SetHeight(35)
Lootscan1.ninjas:SetPoint("TOPLEFT", 110, -6)

Lootscan1.allloot = Lootscan1:CreateTexture(nil, "OVERLAY")
Lootscan1.allloot:SetTexture("Interface\\Addons\\Lootscan\\allloot")
Lootscan1.allloot:SetWidth(35)
Lootscan1.allloot:SetHeight(35)
Lootscan1.allloot:SetPoint("TOPLEFT",110, -6)

Lootscan1.config = Lootscan1:CreateTexture(nil, "OVERLAY")
Lootscan1.config:SetTexture("Interface\\Addons\\Lootscan\\icon-config")
Lootscan1.config:SetWidth(16)
Lootscan1.config:SetHeight(16)
Lootscan1.config:SetPoint("TOPLEFT",160, -4)

Lootscan1.onicon:Hide()
Lootscan1.officon:Show()
Lootscan1.ninjas:Hide()

scrollmessage:SetJustifyH("LEFT")
SLASH_LOOTSCAN1 = "/lootscan";
SLASH_LOOTSCAN2 = "/ls";
SlashCmdList["LOOTSCAN"] = function(msg)
	Lootscan_SlashCommandHandler(msg);
end
end

function Lootscan_SlashCommandHandler(msg)
local frame = getglobal("Lootscan1")
if (frame) then
if (frame:IsVisible() ) then
	frame:Hide();
else
	frame:Show();
end
end
end

function Lootscan_MinimapButton_Reposition()
	Lootscan_MinimapButton:SetPoint("TOPLEFT","Minimap","TOPLEFT",52-(80*cos(Lootscan_Settings.MinimapPos)),(80*sin(Lootscan_Settings.MinimapPos))-52)
end

function Lootscan_MinimapButton_DraggingFrame_OnUpdate()

	local xpos,ypos = GetCursorPosition()
	local xmin,ymin = Minimap:GetLeft(), Minimap:GetBottom()

	xpos = xmin-xpos/UIParent:GetScale()+70 -- get coordinates as differences from the center of the minimap
	ypos = ypos/UIParent:GetScale()-ymin-70

	Lootscan_Settings.MinimapPos = math.deg(math.atan2(ypos,xpos)) -- save the degrees we are relative to the minimap center
	Lootscan_MinimapButton_Reposition() -- move the button
end

function Lootscan_VARIABLES_LOADED()
Lootscan_MinimapButton_Reposition();
LootScan_Font_Slider1:SetValue(fontheight)
LootScan_Scale_Slider1:SetValue(framescale)

for k,v in pairs(LootTable) do

		--Colors
		if (string.find(v, " Death Knight won")) then
		Rdec = 0.77
		Gdec = 0.12
		Bdec = 0.23
		elseif (string.find(v, " Druid won")) then
		Rdec = 1.00
		Gdec = 0.49
		Bdec = 0.04
		elseif (string.find(v, " Hunter won")) then
		Rdec = 0.67
		Gdec = 0.83
		Bdec = 0.45
		elseif (string.find(v, " Mage won")) then
		Rdec = 0.41
		Gdec = 0.80
		Bdec = 0.94
		elseif (string.find(v, " Paladin won")) then
		Rdec = 0.96
		Gdec = 0.55
		Bdec = 0.73
		elseif (string.find(v, " Priest won")) then
		Rdec = 1.00
		Gdec = 1.00
		Bdec = 1.00
		elseif (string.find(v, " Rogue won")) then
		Rdec = 1.00
		Gdec = 0.96
		Bdec = 0.41
		elseif (string.find(v, " Shaman won")) then
		Rdec = 0.14
		Gdec = 0.35
		Bdec = 1.00
		elseif (string.find(v, " Warlock won")) then
		Rdec = 0.58
		Gdec = 0.51
		Bdec = 0.79
		elseif (string.find(v, " Warrior won")) then
		Rdec = 0.78
		Gdec = 0.61
		Bdec = 0.43
		end

scrollmessage:AddMessage(v, Rdec, Gdec, Bdec)
end

for k,v in pairs(ninjaLootTable) do

		--Colors
		if (string.find(v, " Death Knight won")) then
		Rdec = 0.77
		Gdec = 0.12
		Bdec = 0.23
		elseif (string.find(v, " Druid won")) then
		Rdec = 1.00
		Gdec = 0.49
		Bdec = 0.04
		elseif (string.find(v, " Hunter won")) then
		Rdec = 0.67
		Gdec = 0.83
		Bdec = 0.45
		elseif (string.find(v, " Mage won")) then
		Rdec = 0.41
		Gdec = 0.80
		Bdec = 0.94
		elseif (string.find(v, " Paladin won")) then
		Rdec = 0.96
		Gdec = 0.55
		Bdec = 0.73
		elseif (string.find(v, " Priest won")) then
		Rdec = 1.00
		Gdec = 1.00
		Bdec = 1.00
		elseif (string.find(v, " Rogue won")) then
		Rdec = 1.00
		Gdec = 0.96
		Bdec = 0.41
		elseif (string.find(v, " Shaman won")) then
		Rdec = 0.14
		Gdec = 0.35
		Bdec = 1.00
		elseif (string.find(v, " Warlock won")) then
		Rdec = 0.58
		Gdec = 0.51
		Bdec = 0.79
		elseif (string.find(v, " Warrior won")) then
		Rdec = 0.78
		Gdec = 0.61
		Bdec = 0.43
		end

end

end

function Test1_OnEvent()
if (event=="VARIABLES_LOADED") then
	Lootscan_VARIABLES_LOADED();
end

if (onoffCheckButton:GetChecked()) then
        if (event=="CHAT_MSG_LOOT") then
		--capture rolls
	 	if (string.find(arg1, " Roll - ")) then
			RollTable[iRollTable] = arg1
			iRollTable=iRollTable+1
		end
		
		--definition LooterName
	 	if (string.find(arg1, " won:")) then
		        LooterName = strsplit (" ", arg1)
 				if (LooterName == "You") then
					LooterName = UnitName("player")
				end
			--definition LooterClass
       			LooterClass = UnitClass(LooterName)
			
				--reception ItemLink
				for itemLink in arg1:gmatch("|%x+|Hitem:.-|h.-|h|r") do
					myitemLink = itemLink
					name,link=GetItemInfo(myitemLink)
				end
		--i dont know why xD
		name,link = GetItemInfo(myitemLink)
		local idstart, idend = string.find(link,"item:(%d+):(%d+):(%d+):(%d+)");
		local itemid = string.sub(link,idstart,idend);
		blabla,itemid = string.split(":",itemid) 
		--	print(itemid)
		-- defis fix
		newitemname = ""
		ii=0
		while(ii<=string.len(name)) do
			if (string.sub(name,ii,ii)=="-") then
				newitemname = newitemname.."--"
			else
			newitemname = newitemname..string.sub(name,ii,ii)
			end
		ii=ii+1
		end

		--definition RollType
		rolltype = ""
		for k,v in pairs(RollTable) do
			if (string.find(v, " by " .. LooterName)) then
				if (string.find(v, newitemname)) then
					if (string.find(v, "Need Roll")) then
						rolltype = "[need]"
					end
					if (string.find(v, "Greed Roll")) then
						rolltype = "[greed]"
					end
				end
			end
		end

		--old definition ninja
--	for k,v in pairs(table1) do
--		if (string.find(v, newitemname)) then
--		len = string.len(v)
--		var1 = string.find(v, ">>>", 1)
--		var2 = string.sub(v, var1, len)
--		if (string.find(var2, LooterClass, 1)) then
--		ninja = ""
--		else
--			if (rolltype == "[need]") then
--				ninja = "WARNING!"
--			end
--			end
--		end
--		end
--	new definition ninja
	ninja = "bad"
	itemid = tonumber(itemid)
	if (CD[itemid]) then
		for k,v in pairs(CD[itemid]) do
				if (string.find(k, LooterClass)) then
					ninja = "ok"
				end	
		end			
	end
	if (ninja == "bad") and (rolltype == "[need]") then
			ninja = "WARNING!"
	else
			ninja = ""
	end
	
		--Colors
		if (LooterClass == "Death Knight") then
		Rdec = 0.77
		Gdec = 0.12
		Bdec = 0.23
		elseif (LooterClass == "Druid") then
		Rdec = 1.00
		Gdec = 0.49
		Bdec = 0.04
		elseif (LooterClass == "Hunter") then
		Rdec = 0.67
		Gdec = 0.83
		Bdec = 0.45
		elseif (LooterClass == "Mage") then
		Rdec = 0.41
		Gdec = 0.80
		Bdec = 0.94
		elseif (LooterClass == "Paladin") then
		Rdec = 0.96
		Gdec = 0.55
		Bdec = 0.73
		elseif (LooterClass == "Priest") then
		Rdec = 1.00
		Gdec = 1.00
		Bdec = 1.00
		elseif (LooterClass == "Rogue") then
		Rdec = 1.00
		Gdec = 0.96
		Bdec = 0.41
		elseif (LooterClass == "Shaman") then
		Rdec = 0.14
		Gdec = 0.35
		Bdec = 1.00
		elseif (LooterClass == "Warlock") then
		Rdec = 0.58
		Gdec = 0.51
		Bdec = 0.79
		elseif (LooterClass == "Warrior") then
		Rdec = 0.78
		Gdec = 0.61
		Bdec = 0.43
		end
		
		if (rolltype ~= "") then
			if (ninja ~= "") then
			ninjaLootTable[ininjaLootTable] = ninja .. " " .. LooterName .. " " .. LooterClass .. " won " .. rolltype ..     " " .. myitemLink
			ininjaLootTable = ininjaLootTable + 1
			end
		end
		if (rolltype ~= "") then
		LootTable[iLootTable] = ninja .. " " .. LooterName .. " " .. LooterClass .. " won " .. rolltype ..     " " .. myitemLink
		iLootTable = iLootTable + 1
		end
		end
		scrollmessage:Clear();
		if (LootScan_Ninja_Button1:IsVisible() ) then
			for k,v in pairs(ninjaLootTable) do

		--Colors
		if (string.find(v, " Death Knight won")) then
		Rdec = 0.77
		Gdec = 0.12
		Bdec = 0.23
		elseif (string.find(v, " Druid won")) then
		Rdec = 1.00
		Gdec = 0.49
		Bdec = 0.04
		elseif (string.find(v, " Hunter won")) then
		Rdec = 0.67
		Gdec = 0.83
		Bdec = 0.45
		elseif (string.find(v, " Mage won")) then
		Rdec = 0.41
		Gdec = 0.80
		Bdec = 0.94
		elseif (string.find(v, " Paladin won")) then
		Rdec = 0.96
		Gdec = 0.55
		Bdec = 0.73
		elseif (string.find(v, " Priest won")) then
		Rdec = 1.00
		Gdec = 1.00
		Bdec = 1.00
		elseif (string.find(v, " Rogue won")) then
		Rdec = 1.00
		Gdec = 0.96
		Bdec = 0.41
		elseif (string.find(v, " Shaman won")) then
		Rdec = 0.14
		Gdec = 0.35
		Bdec = 1.00
		elseif (string.find(v, " Warlock won")) then
		Rdec = 0.58
		Gdec = 0.51
		Bdec = 0.79
		elseif (string.find(v, " Warrior won")) then
		Rdec = 0.78
		Gdec = 0.61
		Bdec = 0.43
		end

			scrollmessage:AddMessage(v, Rdec, Gdec, Bdec)
			end

		else
		for k,v in pairs(LootTable) do

		--Colors
		if (string.find(v, " Death Knight won")) then
		Rdec = 0.77
		Gdec = 0.12
		Bdec = 0.23
		elseif (string.find(v, " Druid won")) then
		Rdec = 1.00
		Gdec = 0.49
		Bdec = 0.04
		elseif (string.find(v, " Hunter won")) then
		Rdec = 0.67
		Gdec = 0.83
		Bdec = 0.45
		elseif (string.find(v, " Mage won")) then
		Rdec = 0.41
		Gdec = 0.80
		Bdec = 0.94
		elseif (string.find(v, " Paladin won")) then
		Rdec = 0.96
		Gdec = 0.55
		Bdec = 0.73
		elseif (string.find(v, " Priest won")) then
		Rdec = 1.00
		Gdec = 1.00
		Bdec = 1.00
		elseif (string.find(v, " Rogue won")) then
		Rdec = 1.00
		Gdec = 0.96
		Bdec = 0.41
		elseif (string.find(v, " Shaman won")) then
		Rdec = 0.14
		Gdec = 0.35
		Bdec = 1.00
		elseif (string.find(v, " Warlock won")) then
		Rdec = 0.58
		Gdec = 0.51
		Bdec = 0.79
		elseif (string.find(v, " Warrior won")) then
		Rdec = 0.78
		Gdec = 0.61
		Bdec = 0.43
		end

		scrollmessage:AddMessage(v, Rdec, Gdec, Bdec)
		end
		end


	end
end
end

function Report_to_Raid(ninja)
	if (ninja ~="") then
	SendChatMessage("==>> LootScan v0.5 ninja warnings:", "RAID")
		for k,v in pairs(ninjaLootTable) do
		SendChatMessage(v, "RAID")
		end
	else
	SendChatMessage("==>> LootScan v0.5 information about loot:", "RAID")
		for k,v in pairs(LootTable) do
		SendChatMessage(v, "RAID")
		end
	end

end
function Report_to_Party(ninja)
if (ninja ~="") then
	SendChatMessage("==>> LootScan v0.5 ninja warnings:", "PARTY")
	for k,v in pairs(ninjaLootTable) do
	SendChatMessage(v, "PARTY")
	end
else
	SendChatMessage("==>> LootScan v0.5 information about loot:", "PARTY")
	for k,v in pairs(LootTable) do
	SendChatMessage(v, "PARTY")
	end
end
end

function Report_to_Say(ninja)
if (ninja ~="") then
	SendChatMessage("==>> lootscan v0.5 ninja warnings:", "SAY")
	for k,v in pairs(ninjaLootTable) do
	SendChatMessage(v, "say")
	end
else
	SendChatMessage("==>> lootscan v0.5 information about loot:", "SAY")
	for k,v in pairs(LootTable) do
	SendChatMessage(v, "SAY")
	end
end
end

function Report_to_Whisper(ninja,playername)
if (ninja ~="") then
if (playername ~= "") then
	SendChatMessage("==>> LootScan v0.5 ninja warnings:", "WHISPER", nil, playername)
	for k,v in pairs(ninjaLootTable) do
	SendChatMessage(v, "WHISPER", nil, playername)
	end
end
else
if (playername ~= "") then
	SendChatMessage("==>> LootScan v0.5 information about loot:", "WHISPER", nil, playername)
	for k,v in pairs(LootTable) do
	SendChatMessage(v, "WHISPER", nil, playername)
	end
end
end
end

function Report_to_Channel(ninja,channelid)
if (ninja ~="") then
	SendChatMessage("==>> LootScan v0.5 ninja warnings:", "CHANNEL", nil, channelid)
	for k,v in pairs(ninjaLootTable) do
	SendChatMessage(v, "CHANNEL", nil, channelid)
	end
else
	SendChatMessage("==>> LootScan v0.5 information about loot:", "CHANNEL", nil, channelid)
	for k,v in pairs(LootTable) do
	SendChatMessage(v, "CHANNEL", nil, channelid)
	end
end
end


